// -*- mode: c++ -*-
// 
// File MDF.C generated by TMultiDimFit::MakeRealCode
// on Wed Feb  5 16:25:05 2003
// ROOT version 3.05/02
//
// This file contains the function 
//
//    Double_t  MDF(Double_t *x); 
//
// For evaluating the parameterization obtained
// from TMultiDimFit and the point x
// 
// See TMultiDimFit class documentation for more information 
// 
#ifndef __CINT__
#include <Rtypes.h> // needed for Double_t etc
#endif

//
// Static data variables
//
static Int_t    gNVariables    = 4;
static Int_t    gNCoefficients = 27;
static Double_t gDMean         = 45.8383;
// Assignment to mean vector.
static Double_t gXMean[] = {
  -0.0361681, 0.0063121, -0.00773313, 0.023277 };

// Assignment to minimum vector.
static Double_t gXMin[] = {
  0.000501871, 0.00257969, 0.037837, 0.0216842 };

// Assignment to maximum vector.
static Double_t gXMax[] = {
  9.95356, 9.99543, 9.99466, 9.95317 };

// Assignment to coefficients vector.
static Double_t gCoefficient[] = {
  -2.70562,
  43.5518,
  13.5469,
  13.3809,
  36.2558,
  13.5796,
  12.9695,
  13.3757,
  -3.87787,
  4.95866,
  19.8436,
  -0.905388,
  -24.5749,
  -3.59137,
  -4.00688,
  3.15536,
  -4.48568,
  -4.40179,
  -4.60276,
  4.94917,
  4.88633,
  -16.5467,
  5.41597,
  4.6541,
  4.65052,
  4.1057,
  -8.99049
 };

// Assignment to powers vector.
// The powers are stored row-wise, that is
//  p_ij = gPower[i * NVariables + j];
static Int_t    gPower[] = {
  1,  1,  1,  1,
  2,  1,  1,  1,
  1,  1,  2,  1,
  1,  2,  1,  1,
  1,  1,  1,  4,
  2,  2,  1,  1,
  2,  1,  1,  2,
  2,  1,  2,  1,
  1,  2,  1,  2,
  1,  1,  3,  1,
  3,  1,  1,  2,
  1,  3,  1,  3,
  1,  1,  1,  6,
  1,  1,  2,  2,
  1,  2,  2,  1,
  1,  2,  2,  2,
  2,  1,  2,  2,
  2,  2,  1,  2,
  2,  2,  2,  1,
  2,  1,  3,  1,
  2,  3,  1,  1,
  3,  1,  1,  4,
  2,  1,  1,  5,
  1,  1,  1,  3,
  1,  3,  1,  1,
  2,  2,  2,  2,
  5,  1,  1,  2
};

// 
// The function   Double_t MDF(Double_t *x)
// 
Double_t MDF(Double_t *x) {
  Double_t returnValue = gDMean;
  Int_t    i = 0, j = 0;
  for (i = 0; i < gNCoefficients ; i++) {
    // Evaluate the ith term in the expansion
    Double_t term = gCoefficient[i]; <<
    for (j = 0; j < gNVariables; j++) {
      // Evaluate the polynomial in the jth variable.
      Int_t power = gPower[gNVariables * i + j]; 
      Double_t p1 = 1, p2 = 0, p3 = 0, r = 0;
      Double_t v =  1 + 2. / (gXMax[j] - gXMin[j]) * (x[j] - gXMax[j]);
      // what is the power to use!
      switch(power) {
      case 1: r = 1; break; 
      case 2: r = v; break; 
      default: 
        p2 = v; 
        for (i = 3; i <= power; i++) { 
          p3 = p2 * v;
          p1 = p2; p2 = p3; 
        }
        r = p3;
      }
      // multiply this term by the poly in the jth var
      term *= r; 
    }
    // Add this term to the final result
    returnValue += term;
  }
  return returnValue;
}

// EOF for MDF.C
